Summary: GNU C Compiler
Name: gcc
%define version 2.8.1
Version: %{version}
Release: 1
Copyright: GPL
Group: Development/Languages
Source: ftp://prep.ai.mit.edu/pub/gnu/gcc-%{version}.tar.gz
Source1: gcc-c-skel 
Source2: gcc-c++-skel 
Source3: gcc-objc-skel
Requires: binutils
Buildroot: /tmp/gcc-root
Prereq: /sbin/install-info

%changelog

* Wed Mar 4 1998 Jani Hakala <jahakala@cc.jyu.fi>

- updated to 2.8.1

* Tue Jan 15 1998 Jani Hakala <jahakala@cc.jyu.fi>

- updated to 2.8.0
- buildrooted

* Fri Oct 23 1997 Erik Troan <ewt@redhat.com>

- use ld-linux.so.2 on the sparc

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>

- build crtbegin* and crtend* on the sparc

* Mon Sep 29 1997 Erik Troan <ewt@redhat.com>

- added patch from rth to fix dump on alpha w/ building libg++

* Sun Sep 28 1997 Erik Troan <ewt@redhat.com>

- djb really made the crtbegin/end stuff in gcc-c-skel conditional on
  running on an i386 machine, not a !sparc machine; all changed was his
  comment
- added patch to use /lib/ld-linux.so.2 on the alpha

* Tue Sep 23 1997 Richard Henderson <rth@cygnus.com>

- Killed the glibc.patch and added sparc.patch2 to _really_ make
  libgcc.a be compiled with -fPIC.

* Fri Sep 19 1997 Donald Barnes <djb@redhat.com>

- added the glibc.patch so that libgcc.a is compiled with -fPIC
- added %ifarch i386 around crtbegin/end in gcc-c-skel

* Sun Sep 14 1997 Erik Troan <ewt@redhat.com>

- modified to use install-info

* Sun Aug 24 1997 Erik Troan <ewt@redhat.com>

- updated to gcc 2.7.2.3

* Thu Aug 21 1997 Erik Troan <ewt@redhat.com>

- fixed /lib/cpp patch to include redhat element

* Mon Jun 02 1997 Erik Troan <ewt@redhat.com>

- removed HJ's patch
- added patch from Ulrich Drepper to generate crt*.o

%description
The GNU C compiler -- a full featured ANSI C compiler, with support
for K&R C as well. GCC provides many levels of source code error
checking tradionaly provided by other tools (such as lint), produces
debugging information, and can perform many different optimizations to
the resulting object code. This contains the back end for C++ and 
Objective C compilers as well.

%package c++
Summary: C++ support for gcc
Group: Development/Languages
Requires: gcc = %{version}

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does not include a standard C++ library, which
is available separately.

%package objc
Requires: gcc = %{version}
Summary: Objective C support for gcc
Group: Development/Languages

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.

%prep
%setup -q

for n in gcc-c-skel gcc-c++-skel gcc-objc-skel; do
    cp $RPM_SOURCE_DIR/$n ./$n.in
done

%ifarch i386 sparc
cat >> gcc-c-skel.in <<EOF

/usr/lib/gcc-lib/ARCH-redhat-linux/VERSION/crtbegin.o
/usr/lib/gcc-lib/ARCH-redhat-linux/VERSION/crtbeginS.o
/usr/lib/gcc-lib/ARCH-redhat-linux/VERSION/crtend.o
/usr/lib/gcc-lib/ARCH-redhat-linux/VERSION/crtendS.o
EOF

%endif

for n in gcc-c-skel gcc-c++-skel gcc-objc-skel; do
    sed "s/ARCH/${RPM_ARCH}/g" < $n.in | \
	sed "s/VERSION/${RPM_PACKAGE_VERSION}/g" > $n
done


%build

./configure --prefix=/usr --with-local-prefix=/usr/local --with-gxx-include-dir=/usr/include/g++ ${RPM_ARCH}-redhat-linux

make LANGUAGES=c
make stage1
make CC="stage1/xgcc -Bstage1/" CFLAGS="-O" LDFLAGS="-s"
make stage2
make CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"

# For Objective C only
make objc-runtime CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s"

%install
rm -fr $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/lib
make prefix=$RPM_BUILD_ROOT/usr CC="stage2/xgcc -Bstage2/" CFLAGS="-O" LDFLAGS="-s" install

gzip -n -9f $RPM_BUILD_ROOT/usr/info/*.info* 

ln -sf gcc $RPM_BUILD_ROOT/usr/bin/cc
ln -sf cccp.1 $RPM_BUILD_ROOT/usr/man/man1/cpp.1

ln -sf ../usr/lib/gcc-lib/${RPM_ARCH}-redhat-linux/${RPM_PACKAGE_VERSION}/cpp $RPM_BUILD_ROOT/lib/cpp

%clean
rm -fr $RPM_BUILD_ROOT

%post
/sbin/install-info /usr/info/gcc.info.gz /usr/info/dir --entry="* gcc: (gcc).                   The GNU C compiler."

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete /usr/info/gcc.info.gz /usr/info/dir --entry="* gcc: (gcc).                   The GNU C compiler."
fi
%files -f gcc-c-skel
%doc NEWS PROBLEMS
%dir /usr/lib/gcc-lib
/usr/bin/gcc
/usr/bin/gcov
/usr/bin/cc
/usr/bin/protoize
/usr/bin/unprotoize

/lib/cpp

/usr/man/man1/cpp.1
/usr/man/man1/cccp.1
/usr/man/man1/gcc.1

/usr/info/cpp.info*
/usr/info/gcc.info*

%files c++ -f gcc-c++-skel

%files objc -f gcc-objc-skel
